export declare class Result {
    readonly status: number;
    readonly value?: unknown;
    readonly cookies?: unknown;
    readonly headers?: Record<string, string> | undefined;
    protected constructor(status: number, value?: unknown, cookies?: unknown, headers?: Record<string, string> | undefined);
}
export declare class DataResult extends Result {
    private readonly __type;
    constructor(status: number, value?: unknown, cookies?: unknown, headers?: Record<string, string>);
    static ok(value?: unknown, cookies?: unknown, headers?: Record<string, string>): DataResult;
    static error(value?: unknown, cookies?: unknown, headers?: Record<string, string>): DataResult;
    static notFound(cookies?: unknown, headers?: Record<string, string>): DataResult;
    static unauthorized(cookies?: unknown, headers?: Record<string, string>): DataResult;
}
export declare class ViewResult extends Result {
    private readonly __type;
    template?: string;
    redirectUrl?: string;
    constructor(status: number, value?: unknown, cookies?: unknown, headers?: Record<string, string>, template?: string, redirectUrl?: string);
    static ok(template: string, value?: unknown, cookies?: unknown, headers?: Record<string, string>): ViewResult;
    static redirect(url: string, status?: 301 | 302, cookies?: unknown, headers?: Record<string, string>): ViewResult;
    static error(value?: unknown, template?: string, cookies?: unknown, headers?: Record<string, string>): ViewResult;
    static notFound(value?: unknown, template?: string, cookies?: unknown, headers?: Record<string, string>): ViewResult;
    static unauthorized(value?: unknown, template?: string, cookies?: unknown, headers?: Record<string, string>): ViewResult;
}
